# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/postgresql/postgresql/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section free
%define uversion 9.0-801
%define namedversion %{uversion}.jdbc4

Name:           postgresql-jdbc
Version:        9.0.801
Release:        1%{?dist}
Epoch:          0
Summary:        JDBC driver for PostgreSQL
License:        BSD
Group:          Applications/Databases
URL:            http://jdbc.postgresql.org/
Source0:        http://jdbc.postgresql.org/download/postgresql-jdbc-9.0-801.src.tar.gz
Source1:        http://repo1.maven.org/maven2/postgresql/postgresql/9.0-801.jdbc4/postgresql-9.0-801.jdbc4.pom
Obsoletes:      rh-postgresql-jdbc <= %{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  ant >= 0:1.6.2
BuildRequires:  ant-junit >= 0:1.6.2
BuildRequires:  apache-commons-parent
BuildRequires:  gettext
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  junit >= 0:3.7
BuildRequires:  maven2-plugin-deploy
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
PostgreSQL is an advanced Object-Relational database management
system. The postgresql-jdbc package includes the .jar files needed for
Java programs to access a PostgreSQL database.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -c
mv %{name}-%{uversion}.src/* .
rm %{name}-%{uversion}.src/.cvsignore
rmdir %{name}-%{uversion}.src/

%{_bindir}/find -type f -name "*.jar" -or -type f -name "*.class" -o -type f -name ".cvsignore" | %{_bindir}/xargs -t %{__rm}

%build
export OPT_JAR_LIST=`%{__cat} %{_sysconfdir}/ant.d/junit`
export CLASSPATH=
/bin/sh ./update-translations.sh
%{ant} all publicapi

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}
# Per jpp conventions, jars have version-numbered names and we add
# versionless symlinks.
cp -p jars/postgresql.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{jar} cf %{buildroot}%{_javadir}/%{name}-sources-%{namedversion}.jar -C . org/
%{jar} cf %{buildroot}%{_javadir}/%{name}-javadoc-%{namedversion}.jar -C build/publicapi .
ln -s %{name}-%{namedversion}.jar %{buildroot}%{_javadir}/postgresql-jdbc2-%{namedversion}.jar
ln -s %{name}-%{namedversion}.jar %{buildroot}%{_javadir}/postgresql-jdbc2ee-%{namedversion}.jar
ln -s %{name}-%{namedversion}.jar %{buildroot}%{_javadir}/postgresql-jdbc3-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} ${jar/-%{namedversion}/}; done)

mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p %{SOURCE1} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap postgresql postgresql %{namedversion} JPP %{name}

mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr build/publicapi/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=postgresql -DartifactId=postgresql -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}-%{namedversion}.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew -DrepositoryId=jboss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=postgresql -DartifactId=postgresql -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}-javadoc-%{namedversion}.jar -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew -DrepositoryId=jboss-releases -Dclassifier=javadoc
%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=postgresql -DartifactId=postgresql -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}-sources-%{namedversion}.jar -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew -DrepositoryId=jboss-releases -Dclassifier=sources
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf %{buildroot}

%post
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif
%update_maven_depmap

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc LICENSE README doc/*
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-javadoc-%{namedversion}.jar
%{_javadir}*/%{name}-javadoc.jar
%{_javadir}*/%{name}-sources-%{namedversion}.jar
%{_javadir}*/%{name}-sources.jar
%{_javadir}*/postgresql-jdbc2-%{namedversion}.jar
%{_javadir}*/postgresql-jdbc2.jar
%{_javadir}*/postgresql-jdbc2ee-%{namedversion}.jar
%{_javadir}*/postgresql-jdbc2ee.jar
%{_javadir}*/postgresql-jdbc3-%{namedversion}.jar
%{_javadir}*/postgresql-jdbc3.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.db
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.so
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*/
%dir %{_javadir}*/repository.jboss.com
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Dec 17 2010 David Walluck <dwalluck@redhat.com> 0:9.0.801-1
- 9.0-801

* Tue Mar 10 2009 David Walluck <dwalluck@redhat.com> 0:8.3.604-1
- 8.3.604

* Thu Aug 17 2006 Fernando Nasser <fnasser@redhat.com> 8.1.407-2jpp
  From Tom Lane <tgl@redhat.com>:
- Fix Requires: for rebuild-gcj-db

* Wed Jun 14 2006 Tom Lane <tgl@redhat.com> 8.1.407-1jpp
- Update to build 8.1-407

* Mon Mar 27 2006 Tom Lane <tgl@redhat.com> 8.1.405-2jpp
- Back-patch upstream fix to support unspecified-type strings.

* Thu Feb 16 2006 Tom Lane <tgl@redhat.com> 8.1.405-1jpp
- Split postgresql-jdbc into its own SRPM (at last).
- Build it from source.  Add support for gcj compilation.
